# generated by cabal-rpm-0.12.5
# https://fedoraproject.org/wiki/Packaging:Haskell

%global pkg_name cabal-helper
%global pkgver %{pkg_name}-%{version}

%ifarch x86_64 %{ix86}
%bcond_without tests
%else
%bcond_with tests
%endif

Name:           ghc-%{pkg_name}
Version:        0.8.0.2
Release:        6%{?dist}
Summary:        Simple interface to some of Cabal's configuration state, mainly used by ghc-mod

License:        AGPLv3
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkgver}/%{pkg_name}.cabal#/%{pkgver}.cabal

# Don't try to download and build every single cabal version.
Patch0001:      Test-only-our-cabal-install.patch

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
# Begin cabal-rpm deps:
BuildRequires:  cabal-install
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-semigroupoids-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-temporary-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unix-compat-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-utf8-string-devel
%if %{with tests}
BuildRequires:  ghc-ghc-devel
BuildRequires:  ghc-ghc-paths-devel
# tests/bkpregex.cabal
BuildRequires:  ghc-bytestring-devel
# tests/exeintlib.cabal
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
# tests/exelib.cabal
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
# tests/fliblib.cabal
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
%endif
# End cabal-rpm deps

%description
Cabal's little helper provides access to build information gathered by 'cabal'
when configuring a project. Specifically we're interested in retrieving enough
information to bring up a compiler session, using the GHC API, which is similar
to running 'cabal repl' in a project.

While simple in principle this is complicated by the fact that the information
Cabal writes to disk is in an unstable format and only really accessible
through the Cabal API itself.

Since we do not want to bind the user of a development tool which utilises this
library to a specific version of Cabal we compile the code which interfaces
with the Cabal library's API on the user's machine, at runtime, against
whichever version of Cabal was used to write the on disk information for a
given project.

If this version of Cabal is not available on the users machine anymore, which
is fairly likely since cabal-install is usually linked statically, we have
support for compiling the Cabal library also. In this case the library is
installed into a private, isolated, package database in
'$XDG_CACHE_HOME/cabal-helper' so as to not interfere with the user's package
database.


%package devel
Summary:        Haskell %{pkg_name} library development files
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-doc = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}
%endif
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
This package provides the Haskell %{pkg_name} library development files.


%prep
%autosetup -n %{pkgver} -p1


%build
%ghc_lib_build


%install
%ghc_lib_install


%check
# Don't add any servers to cabal config, so it
# doesn't try to download anything.
mkdir -p home/.cabal
echo > home/.cabal/config

# Cannot run build tests that use the network.
%global cabal_test_options ghc-session
HOME=$PWD/home %cabal_test


%post devel
%ghc_pkg_recache


%postun devel
%ghc_pkg_recache


%files -f %{name}.files
%license LICENSE
%{_bindir}/cabal-helper-main


%files devel -f %{name}-devel.files
%doc README.md
%dir %{_libexecdir}/%{pkgver}
%{_libexecdir}/%{pkgver}/cabal-helper-wrapper


%changelog
* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.8.0.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 28 2018 Jens Petersen <petersen@redhat.com> - 0.8.0.2-5
- revise .cabal
- run testsuite only on Intel archs (failing elsewhere)

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8.0.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Jul 09 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.8.0.2-3
- Build with tests enabled

* Mon Apr 09 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.8.0.2-2
- Use macro-defined location for private executables (#1563863)

* Wed Apr  4 2018 Fedora Haskell SIG <haskell@lists.fedoraproject.org> - 0.8.0.2-1
- spec file generated by cabal-rpm-0.12.1
